package binarytree.core;

import java.util.Optional;
import java.util.function.Consumer;

public class TreeNode<T extends Comparable<T>> {
	private Optional<TreeNode<T>> left = Optional.empty(), right = Optional.empty();
	private T value;
	
	public TreeNode(T value) {
		this.value = value;
	}

	public T get() {return value;}
	public Optional<TreeNode<T>> getLeft() {return left;}	
	public Optional<TreeNode<T>> getRight() {return right;}
	public boolean isLeaf() {return !left.isPresent() && !right.isPresent();}
	
	public void insert(T value) {
		// TODO: Insert a new node containing value, preserving the ordering.
	}
	
	public boolean contains(T value) {
		// TODO: Return true if value is present in the tree, false otherwise
		return false;
	}
	
	public int height() {
		// TODO: Return the height of the tree, which is the maximum number of
		// edges between the root and any leaf.
		return 0;
	}
	
	public int size() {
		// TODO: Return the number of nodes in the tree. 
		return 0;
	}
	
	public T getMin() {
		// TODO: Return the smallest value in the tree.
		return null;
	}
	
	public T getMax() {
		// TODO: Return the largest value in the tree.
		return null;
	}

	public void preOrder(Consumer<T> op) {
		// TODO: Perform a preorder traversal
	}
	
	public void postOrder(Consumer<T> op) {
		// TODO: Perform a postorder traversal
	}
	
	public void inOrder(Consumer<T> op) {
		// TODO: Perform an inorder traversal
	}
	
	public TreeNode<T> leftRotateAt(T value) {
		// TODO:
		// - If value is present in the tree, perform a left rotation of 
		//   the node containing it, and return its new parent node.
		// - If value is not present, just return this.
		return this;
	}

	public TreeNode<T> rightRotateAt(T value) {
		// TODO:
		// - If value is present in the tree, perform a right rotation of 
		//   the node containing it, and return its new parent node.
		// - If value is not present, just return this.
		return this;
	}
	
	public Optional<TreeNode<T>> remove(T target) {
		// TODO:
		// - If target is less than value:
		//   - Set the left child to be the result of calling this method recursively.
		// - If target is greater than value:
		//   - Set the right child to be the result of calling this method recursively.
		// - If target and value are equivalent:
		//   - If it is at a leaf, return Optional.empty()
		//   - If it has exactly one child, return that child
		//   - If it has two children, copy the maximum value of the left child,
		//     and then set the left child to the result of a recursive call
		//     with that maximum value as the parameter.
		return Optional.of(this);
	}
}
